//Let's put global stuff in a class, make it easier to work with.

#pragma once
#include "stdafx.h"
#include "CThingList.h"
#include "cdx.h"

class CThingMouse; //forward dec
class CThingLogic; 
class CThingSprite;

class CGlobals
{

public:

    CDXScreen *m_Screen;     // Required object that contains everything needed to allow us to control the screen
    HINSTANCE m_hInst;                             // Instance handle
    HWND m_hWnd;      
    CThingList *m_p_thing_list;
    unsigned int m_ui_time;
    unsigned int m_ui_time_last;
    float m_f_delta;
    float m_f_fps;
    int m_i_elapsed_frames;
    unsigned int m_ui_fps_counter;
    CDXInput * m_p_input;
    CThingMouse * p_mouse;
    CThingLogic *p_logic;
    CDXSound *m_p_sound;
    CDXSprite * p_hack_sprite; //only way I could get CDX to do a sprite/coord hittest
    CThingSprite *m_p_bg; 

    CGlobals()
    {
        //clear everything at the start
        ZeroMemory(this, sizeof(CGlobals));
         init_timer();
       m_p_thing_list = new CThingList();
       m_ui_fps_counter = get_time()+1000;
       m_p_input = new CDXInput();
       m_p_sound = new CDXSound();
       
    }
    ~CGlobals()
    {
        SAFE_DELETE(m_p_thing_list); 
        SAFE_DELETE(m_p_input);
        SAFE_DELETE(m_p_sound);
    }

    void UpdateTick()
    {
        
        m_ui_time_last = m_ui_time;
        m_ui_time = get_time();
        if (m_ui_time_last == 0) m_ui_time_last = m_ui_time;

        //calculate our delta time for framerate independent movement.
        
        if (m_ui_time - m_ui_time_last != 0)
        {
            m_f_delta = (float(m_ui_time-m_ui_time_last)/1000);
        }
        
       m_i_elapsed_frames++;

       if (m_ui_fps_counter < m_ui_time )
       {
           //time to calculate the frames per second
           m_f_fps =m_i_elapsed_frames;
           m_i_elapsed_frames = 0;
           m_ui_fps_counter = m_ui_time + 1000;
       }

    }

};

extern CGlobals glo;

