#pragma once
#include "stdafx.h"
#include "assert.h"


const int C_THING_MAX_NAME_SIZE = 32;


const int C_THING_TYPE_UNKNOWN = 0;

//used for passing messages
class CMessage
{
public:
  bool m_b_hit;
};


class CThing 
{


public:
    CThing()
    {
        m_i_index = -1;
        SetName("Unknown");
        m_i_type = C_THING_TYPE_UNKNOWN;
        m_i_sort = 10; //default sort
        m_b_sort_request = true;
        m_b_delete_request = false;
    }    
    
    virtual ~CThing() {};
   
    void SetIndex(int i_new){m_i_index = i_new;}
    int GetIndex(){return m_i_index;}
    
    void SetType(int i_new){m_i_type = i_new;}
    int GetType(){return m_i_type;}

    void SetName(char *p_new)
    {
        assert(strlen(p_new) < C_THING_MAX_NAME_SIZE);
        strcpy(m_st_name, p_new);
    }

    bool GetDeleteRequest(){return m_b_delete_request;} 
    void SetDeleteRequest(bool b_new){m_b_delete_request = b_new;}
     
    virtual void Draw() {};
    virtual void Think() {};
    
    int GetSort(){return m_i_sort;}
    void SetSort(int i_new)
    {
             m_i_sort = i_new;
    }
    virtual void ProcessMessage(int i_message, void *p_struct) {}; //handle global messages
  

private:

    int m_i_index;
    char m_st_name[C_THING_MAX_NAME_SIZE];
    int m_i_type;
    int m_i_sort; //what order this gets processed and drawn in
    bool m_b_sort_request; //if true, wants to be sorted
    bool m_b_delete_request; //if true will get deleted when possible
};